/****************************************************************************
*                                                                           *
*              / OOP_DEMO.PRG                                               *
*                                                                           *
*         Autor: M.Rinninger                                                *
*   Erstellt am:  02-23-95      /  06:52:17pm                               *
*  berarbeitet: 02-23-95      / 06:52:17pm                               *
*           von:                                                            *
*     Copyright: (c) 1995 by Ob-Tec Austria                                 *
*                                                                           *
****************************************************************************/

   #include "schedule.ch"
   #include "class(y).ch"

   /*

   This demo shows how methods can be send to an object through
   the scheduler as a conveniecen way to build a multitasking
   enviroment...

   */

function main()

   local getList := {}
   local xValue  := space( 30)

   // create four counter objects ...
   //----------------------------------
   local counter := { Counter():new( 7, 30, 1,    10),;
                      Counter():new( 8, 30, 2,   100),;
                      Counter():new( 9, 30, 3,  1000),;
                      Counter():new(10, 30, 4, 10000) }

   cls

   SchedInit()

   // add different threads for incrementing
   // and displaying the counters  ...
   //----------------------------------------
   SchedAdd( counter[ 1], #:increment())
   SchedAdd( counter[ 1], #:display())

   SchedAdd( counter[ 2], #:increment())
   SchedAdd( counter[ 2], #:display())

   SchedAdd( counter[ 3], #:increment())
   SchedAdd( counter[ 3], #:display(), 9)  // display third counter
                                           // only 2 times a second !
   SchedAdd( counter[ 4], #:increment())
   SchedAdd( counter[ 4], #:display())

   // after approx. 10 sec. (== 182 ticks),
   // we'll kill the second counter ...
   //----------------------------------------
   SchedAdd( {||SchedKill( counter[ 2]:kill())},,,182)

   SchedEnable()

   setcolor( "W+/N")
   @ 1, 5 say "These counters are incrementing and displaying in the background,"
   @ 2, 5 say "while normal processing goes ahead. The second counter, however,"
   @ 3, 5 say "will stop processing after approx. 10 sec. during a 'SchedKill()'"
   @ 4, 5 say "which itself is a thread on its own. whereas the third counter "
   @ 5, 5 say "is displaying its value only two times a second ..."

   // let's do some input ...
   //------------------------
   @ 12, 5 say "Now, this a normal get where you can type in while "
   @ 13, 5 say "the counters are still running :"
   @ 14, 5 get xValue
   read

   cls

   ? "Now, please wait while the Scheduler is measuring the throughput ..."
   ?
   ? SchedInfo()

   // at least, remove the scheduler ...
   //----------------------------------------
   SchedKill()


return( true)

create class Counter()

export:

   var value
   var steps
   var max
   var row
   var col

   method display
   method increment
   method init
   method kill

end class

method init( nRow, nCol, nStep, nMax)

   ::value := 0
   ::row   := nRow
   ::col   := nCol
   ::steps := nStep
   ::max   := nMax

return( self)

method display( nDelay)

   @ ::row, ::col say ::value color "BG/N"

   // add a new instance to the scheduler ...
   // we are usin the same value as a paramter to
   // 'display()' and as the delay for the execution !
   //-----------------------------------------------------
   SchedAdd( self, #:display(), nDelay, nDelay)

return( self)

method increment()

   ::value := (::value + ::steps) % ::max

   // add a new instance to the scheduler ...
   //------------------------------------------
   SchedAdd( self, #:increment(),,,false,"incr..")

return( self)

method kill()

   tone(1361,1)

   @ ::row, ::col say "   --killed--" color "R/N"

return( self)
